package com.eactive.eai.rms.bap.manage.message.flowstep;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.servlet.ModelAndView;

import com.eactive.eai.agent.command.CommonCommand;
import com.eactive.eai.rms.common.base.BapBaseAnnotationController;
import com.eactive.eai.rms.common.util.CamelCaseUtil;
import com.eactive.eai.rms.common.vo.JsonPageVo;

@Controller
public class BapFlowStepController extends BapBaseAnnotationController  {

	@Autowired
	@Qualifier("bapFlowStepService")
	private BapFlowStepService service;
	
	@RequestMapping(value= "/bap/admin/message/flowStepMan.view")
	public String viewList(HttpServletRequest request, @RequestParam(value = "cmd", required = false ) String cmd ) throws Exception {
		if (cmd == null || "LIST".equals(cmd.toUpperCase())){
			cmd = "";
		}else {
			cmd = CamelCaseUtil.converCamelCase(cmd);
		}
		String path = request.getServletPath();
		return path.split("[.]")[0]+cmd;
	}
	
	/**
	 * @param request
	 * @param response
	 * @throws Exception
	 */
	@RequestMapping(value= "/bap/admin/message/flowStepMan.json", params = "cmd=LIST")
	public ModelAndView selectList(HttpServletRequest request,
			JsonPageVo pageVo , @RequestParam HashMap<String, Object> paramMap) throws Exception {

		HashMap<String, Object> map = service.selectList( pageVo.getStartNum(), pageVo.getEndNum(), paramMap);
		
		pageVo.setTotalCount((Integer)map.get("totalCount"));
		
		Map<String, Object> resultMap = new HashMap<String, Object>();
		resultMap.put("total"  , pageVo.getTotal());  //전체 페이지수
		resultMap.put("page"   , pageVo.getPage());   //현재 페이지수
		resultMap.put("records", pageVo.getTotalCount());//전체 레코드건수	
		resultMap.put("rows"   , map.get("list"));
		
		ModelAndView modelAndView = new ModelAndView("jsonView",resultMap);		
		return modelAndView;
		
	}

	@RequestMapping(value= "/bap/admin/message/flowStepMan.json",params = "cmd=DETAIL")
	public ModelAndView selectDetail(HttpServletRequest request,
			HttpServletResponse response, @RequestParam HashMap<String, Object> paramMap ) throws Exception {
		// key = telgmClsID
		
		HashMap<String, Object> map = service.selectDetail(paramMap);
		
		ModelAndView modelAndView = new ModelAndView("jsonView", map);	
		
		return modelAndView;
	}
	@RequestMapping(value= "/bap/admin/message/flowStepMan.json",params = "cmd=LIST_DETAIL_COMBO")
	public ModelAndView selectDetailCombo(HttpServletRequest request,
			HttpServletResponse response, @RequestParam HashMap<String,Object> paramMap) throws Exception {
		// key = TelgmClsName
		HashMap<String, Object> map = service.selectDetailCombo(paramMap);
		
		ModelAndView modelAndView = new ModelAndView("jsonView", map);	
		
		return modelAndView;
	}	
	@RequestMapping(value= "/bap/admin/message/flowStepMan.json",params = "cmd=INSERT")
	public String insert(HttpServletRequest request,
			HttpServletResponse response,@RequestParam HashMap<String,Object> map ) throws Exception {

		service.insert(map);
		CommonCommand command = new CommonCommand("com.eactive.eai.agent.rule.nodeinfo.UpdateNodeInfoCommand", map.get("bjobBzwkPrcssDstcd"));
		agentUtilService.broadcast(command);
    	return null;
		
	}	
	@RequestMapping(value= "/bap/admin/message/flowStepMan.json",params = "cmd=UPDATE")
	public String update(HttpServletRequest request,
			HttpServletResponse response, @RequestParam HashMap<String, Object> map ) throws Exception {
		
		service.update(map);
		CommonCommand command = new CommonCommand("com.eactive.eai.agent.rule.nodeinfo.UpdateNodeInfoCommand", map.get("bjobBzwkPrcssDstcd"));
		agentUtilService.broadcast(command);
		return null;
		
	}
	@RequestMapping(value= "/bap/admin/message/flowStepMan.json",params = "cmd=DELETE")
	public String delete(HttpServletRequest request,
			HttpServletResponse response, @RequestParam HashMap<String, Object> map ) throws Exception {
		
		service.delete(map);
		CommonCommand command = new CommonCommand("com.eactive.eai.agent.rule.nodeinfo.RemoveNodeInfoCommand", map.get("bjobBzwkPrcssDstcd"));
		agentUtilService.broadcast(command);
		return null;
		
	}
	@RequestMapping(value= "/bap/admin/message/flowStepMan.json",params = "cmd=LIST_DELETE")
	public String deleteList(HttpServletRequest request,
			HttpServletResponse response, @RequestParam HashMap<String, Object> map ) throws Exception {
		
		String[] bjobBzwkPrcssDstcdList = map.get("bjobBzwkPrcssDstcdList").toString().split(",");
		String[] bjobStgeDstcdList = map.get("bjobStgeDstcdList").toString().split(",");
		for (int i=0; i<bjobBzwkPrcssDstcdList.length; i++) {
			HashMap<String, Object> paramMap = new HashMap<String, Object>();
			paramMap.put("bjobBzwkPrcssDstcd", bjobBzwkPrcssDstcdList[i]);
			paramMap.put("bjobStgeDstcd", bjobStgeDstcdList[i]);		
			service.delete(paramMap);
			CommonCommand command = new CommonCommand("com.eactive.eai.agent.rule.telegraminfo.RemoveTelegramInfoCommand", bjobBzwkPrcssDstcdList[i]);
			agentUtilService.broadcast(command);
		}
		
		return null;
	}	
	@SuppressWarnings("unchecked")
	@RequestMapping(value= "/bap/admin/message/flowStepMan.json",params = "cmd=LIST_DOWNLOAD_SQL")
	public ModelAndView downloadSql(HttpServletRequest request,
		HttpServletResponse response,@RequestParam HashMap<String,Object> map) throws Exception {		

		List<Map<String, Object>> flowStepInfoList = new ArrayList<Map<String, Object>>();
		String[] searchBjobBzwkPrcssDstcdList = map.get("searchBjobBzwkPrcssDstcdList").toString().split(",");
		String[] searchBjobStgeDstcdList = map.get("searchBjobStgeDstcdList").toString().split(",");
		for (int i=0; i<searchBjobBzwkPrcssDstcdList.length; i++) {
			HashMap<String, Object> paramMap = new HashMap<String, Object>();
			paramMap.put("key", searchBjobBzwkPrcssDstcdList[i]);
			paramMap.put("key2", searchBjobStgeDstcdList[i]);
			HashMap<String, Object> flowStepMap = service.selectDetail(paramMap);
			flowStepInfoList.add((Map<String, Object>)flowStepMap.get("list"));
		}

		HashMap<String,Object> flowStepInfo = new HashMap<String,Object>();
		flowStepInfo.put("list", flowStepInfoList);
		flowStepInfo.put("fileName", map.get("fileName"));
		flowStepInfo.put("svrType", map.get("svrType"));

    	ModelAndView modelAndView = new ModelAndView("jsonView",service.mkInserSqlForFlowSteps(flowStepInfo));	
		
		return modelAndView;
	}
	@RequestMapping(value= "/bap/admin/message/flowStepMan.view",params = "cmd=LIST_FILE_DOWNLOAD")
	public String fileDownload(HttpServletRequest request) throws Exception {
		
		return "/bap/admin/common/filedownload";
	}
}